--- wcfxo.c	2004-07-30 11:25:29.000000000 +0200
+++ wcfxo.dk.c	2004-07-30 11:32:23.000000000 +0200
@@ -125,6 +125,7 @@
 #ifdef	JAPAN
 	int ohdebounce;
 #endif
+	int readcid;
 	int allread;
 	int regoffset;			/* How far off our registers are from what we expect */
 	int alt;
@@ -327,6 +328,20 @@
 		}
 		/* Look for pegging to indicate ringing */
 		sample = (short)(le32_to_cpu(readchunk[(x << 1) + (1 - wc->alt)]) >> 16);
+		if (!wc->readcid && !wc->ringdebounce) {
+			if (sample > 32000) {
+				wc->readcid = 1;
+				if (debug)
+					printk("DTMF CLI\n");
+				zt_hooksig(&wc->chan, ZT_RXSIG_POLARITY);
+			}
+			if (sample < -32000) {
+				wc->readcid = 1;
+				if (debug)
+					printk("DTMF CLI\n");
+				zt_hooksig(&wc->chan, ZT_RXSIG_POLARITY);
+			}
+		}
 		if ((sample > 32000) && (wc->peg != 1)) {
 			if ((wc->pegtimer < PEGTIME) && (wc->pegtimer > MINPEGTIME))
 				wc->pegcount++;
@@ -606,6 +621,7 @@
 		reg = reg | 0x08;
 		wcfxo_setreg(wc, 0x5, reg);
 		wc->offhook = 0;
+		wc->readcid = 0;
 		/* Don't accept a ring for another 1000 ms */
 		wc->ringdebounce = 1000;
 #ifdef	JAPAN
